## GtkEditable

GtkEditable — Interface for text-editing widgets

## Functions

void | gtk_editable_select_region ()
gboolean | gtk_editable_get_selection_bounds ()
void | gtk_editable_insert_text ()
void | gtk_editable_delete_text ()
gchar * | gtk_editable_get_chars ()
void | gtk_editable_cut_clipboard ()
void | gtk_editable_copy_clipboard ()
void | gtk_editable_paste_clipboard ()
void | gtk_editable_delete_selection ()
void | gtk_editable_set_position ()
gint | gtk_editable_get_position ()
void | gtk_editable_set_editable ()
gboolean | gtk_editable_get_editable ()

## Signals

void | changed | Run Last
void | delete-text | Run Last
void | insert-text | Run Last

## Types and Values

| GtkEditable

## Object Hierarchy

        GInterface
        ╰── GtkEditable

## Known Implementations

GtkEditable is implemented by GtkEntry, GtkSearchEntry and GtkSpinButton.

## Includes

    #include <gtk/gtk.h>

## Description

The GtkEditable interface is an interface which should be implemented by text editing widgets, such as GtkEntry and GtkSpinButton. It contains functions for generically manipulating an editable widget, a large number of action signals used for key bindings, and several signals that an application can connect to to modify the behavior of a widget.

As an example of the latter usage, by connecting the following handler to “insert-text”, an application can convert all entry into a widget into uppercase.

#### Forcing entry to uppercase.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21

    #include <ctype.h>;

    void
    insert_text_handler (GtkEditable *editable,
                         const gchar *text,
                         gint         length,
                         gint        *position,
                         gpointer     data)
    {
      gchar *result = g_utf8_strup (text, length);

      g_signal_handlers_block_by_func (editable,
                                   (gpointer) insert_text_handler, data);
      gtk_editable_insert_text (editable, result, length, position);
      g_signal_handlers_unblock_by_func (editable,
                                         (gpointer) insert_text_handler, data);

      g_signal_stop_emission_by_name (editable, "insert_text");

      g_free (result);
    }

## Functions

### gtk_editable_select_region ()

    void
    gtk_editable_select_region (GtkEditable *editable,
                                gint start_pos,
                                gint end_pos);

Selects a region of text. The characters that are selected are those characters at positions from `start_pos` up to, but not including `end_pos` . If `end_pos` is negative, then the characters selected are those characters from `start_pos` to the end of the text.

Note that positions are specified in characters, not bytes.

[virtual set_selection_bounds]

#### Parameters

editable | a GtkEditable |
start_pos | start of region |
end_pos | end of region |

### gtk_editable_get_selection_bounds ()

    gboolean
    gtk_editable_get_selection_bounds (GtkEditable *editable,
                                       gint *start_pos,
                                       gint *end_pos);

Retrieves the selection bound of the editable. start_pos will be filled with the start of the selection and `end_pos` with end. If no text was selected both will be identical and `FALSE` will be returned.

Note that positions are specified in characters, not bytes.

#### Parameters

editable | a GtkEditable |
start_pos | location to store the starting position, or `NULL`. | [out][allow-none]
end_pos | location to store the end position, or `NULL`. | [out][allow-none]

#### Returns

`TRUE` if an area is selected, `FALSE` otherwise

### gtk_editable_insert_text ()

    void
    gtk_editable_insert_text (GtkEditable *editable,
                              const gchar *new_text,
                              gint new_text_length,
                              gint *position);

Inserts `new_text_length` bytes of `new_text` into the contents of the widget, at position `position` .

Note that the position is in characters, not in bytes. The function updates `position` to point after the newly inserted text.

[virtual do_insert_text]

#### Parameters

editable | a GtkEditable |
new_text | the text to append |
new_text_length | the length of the text in bytes, or -1 |
position | location of the position text will be inserted at. | [inout]

### gtk_editable_delete_text ()

    void
    gtk_editable_delete_text (GtkEditable *editable,
                              gint start_pos,
                              gint end_pos);

Deletes a sequence of characters. The characters that are deleted are those characters at positions from `start_pos` up to, but not including `end_pos` . If `end_pos` is negative, then the characters deleted are those from `start_pos` to the end of the text.

Note that the positions are specified in characters, not bytes.

[virtual do_delete_text]

#### Parameters

editable | a GtkEditable |
start_pos | start position |
end_pos | end position |

### gtk_editable_get_chars ()

    gchar *
    gtk_editable_get_chars (GtkEditable *editable,
                            gint start_pos,
                            gint end_pos);

Retrieves a sequence of characters. The characters that are retrieved are those characters at positions from `start_pos` up to, but not including `end_pos` . If `end_pos` is negative, then the characters retrieved are those characters from `start_pos` to the end of the text.

Note that positions are specified in characters, not bytes.

#### Parameters

editable | a GtkEditable |
start_pos | start of text |
end_pos | end of text |

#### Returns

a pointer to the contents of the widget as a string. This string is allocated by the GtkEditable implementation and should be freed by the caller.

### gtk_editable_cut_clipboard ()

    void
    gtk_editable_cut_clipboard (GtkEditable *editable);

Removes the contents of the currently selected content in the editable and puts it on the clipboard.

#### Parameters

editable | a GtkEditable |

### gtk_editable_copy_clipboard ()

    void
    gtk_editable_copy_clipboard (GtkEditable *editable);

Copies the contents of the currently selected content in the editable and puts it on the clipboard.

#### Parameters

editable | a GtkEditable |

### gtk_editable_paste_clipboard ()

    void
    gtk_editable_paste_clipboard (GtkEditable *editable);

Pastes the content of the clipboard to the current position of the cursor in the editable.

#### Parameters

editable | a GtkEditable |

### gtk_editable_delete_selection ()

    void
    gtk_editable_delete_selection (GtkEditable *editable);

Deletes the currently selected text of the editable. This call doesn’t do anything if there is no selected text.

#### Parameters

editable | a GtkEditable |

### gtk_editable_set_position ()

    void
    gtk_editable_set_position (GtkEditable *editable,
                               gint position);

Sets the cursor position in the editable to the given value.

The cursor is displayed before the character with the given (base 0) index in the contents of the editable. The value must be less than or equal to the number of characters in the editable. A value of -1 indicates that the position should be set after the last character of the editable. Note that `position` is in characters, not in bytes.

#### Parameters

editable | a GtkEditable |
position | the position of the cursor |

### gtk_editable_get_position ()

    gint
    gtk_editable_get_position (GtkEditable *editable);

Retrieves the current position of the cursor relative to the start of the content of the editable.

Note that this position is in characters, not in bytes.

#### Parameters

editable | a GtkEditable |

#### Returns

the cursor position

### gtk_editable_set_editable ()

    void
    gtk_editable_set_editable (GtkEditable *editable,
                               gboolean is_editable);

Determines if the user can edit the text in the editable widget or not.

#### Parameters

editable | a GtkEditable |
is_editable | `TRUE` if the user is allowed to edit the text in the widget |

### gtk_editable_get_editable ()

    gboolean
    gtk_editable_get_editable (GtkEditable *editable);

Retrieves whether `editable` is editable. See `gtk_editable_set_editable()`.

#### Parameters

editable | a GtkEditable |

#### Returns

`TRUE` if `editable` is editable.

## Types and Values

### GtkEditable

    typedef struct _GtkEditable GtkEditable;

## Signal Details

### The `“changed”` signal

    void
    user_function (GtkEditable *editable,
                   gpointer     user_data)

The ::changed signal is emitted at the end of a single user-visible operation on the contents of the GtkEditable.

E.g., a paste operation that replaces the contents of the selection will cause only one signal emission (even though it is implemented by first deleting the selection, then inserting the new content, and may cause multiple ::notify::text signals to be emitted).

#### Parameters

editable | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“delete-text”` signal

    void
    user_function (GtkEditable *editable,
                   gint         start_pos,
                   gint         end_pos,
                   gpointer     user_data)

This signal is emitted when text is deleted from the widget by the user. The default handler for this signal will normally be responsible for deleting the text, so by connecting to this signal and then stopping the signal with `g_signal_stop_emission()`, it is possible to modify the range of deleted text, or prevent it from being deleted entirely. The `start_pos` and `end_pos` parameters are interpreted as for `gtk_editable_delete_text()`.

#### Parameters

editable | the object which received the signal |
start_pos | the starting position |
end_pos | the end position |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“insert-text”` signal

    void
    user_function (GtkEditable *editable,
                   gchar       *new_text,
                   gint         new_text_length,
                   gpointer     position,
                   gpointer     user_data)

This signal is emitted when text is inserted into the widget by the user. The default handler for this signal will normally be responsible for inserting the text, so by connecting to this signal and then stopping the signal with `g_signal_stop_emission()`, it is possible to modify the inserted text, or prevent it from being inserted entirely.

#### Parameters

editable | the object which received the signal |
new_text | the new text to insert |
new_text_length | the length of the new text, in bytes, or -1 if new_text is nul-terminated |
position | the position, in characters, at which to insert the new text. this is an in-out parameter. After the signal emission is finished, it should point after the newly inserted text. | [inout][type int]
user_data | user data set when the signal handler was connected. |

Flags: Run Last